package test;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;

import org.testng.annotations.Test;

public class NativeQueryTest {

    @Test
    public void test() {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("testUnit");
        EntityManager em = emf.createEntityManager();

        em.getTransaction().begin();
        Person p = new Person("Jason Bourne");
        p.addSth(new Something("something"));
        em.persist(p);
        p = new Person("Jason Bourne II");
        p.addSth(new Something("something II"));
        em.persist(p);
        em.getTransaction().commit();
        em.clear();

        // the 'where' is just to test if the query can be anything more than a simple 'select all'
        Query q = em.createNativeQuery("select pe.* from Person pe where pe.id < 1", Person.class);
        // Query q = em.createQuery("select pe from Person pe where pe.id < 1", Person.class);
        q.setHint("eclipselink.batch", "pe.sths"); // NPE, unless the fix is used, but then the SQL retrieves all Somethings that have a Person
        // for JPQL it adds the 'where pe.id < 1" part from the first query
        System.out.println(">>>>>");
        @SuppressWarnings("unchecked")
        List<Person> people = q.getResultList();
        System.out.println(">>>>>");
        for (Person pe : people) {
            System.out.println(pe);
            pe.getSomethings().size();
            System.out.println(pe);
        }
        System.out.println(">>>>>");
        emf.close();
    }

}
